<?php

namespace Drupal\tranc;

use Drupal\Core\Extension\ThemeHandlerInterface;

/**
 * Wires in the TrancNodeVisitor.
 */
class TrancTwigExtension extends \Twig_Extension {

  /**
   * The theme handler.
   *
   * @var \Drupal\Core\Extension\ThemeHandlerInterface
   */
  protected $themeHandler;

  /**
   * TrancTwigExtension constructor.
   *
   * @param \Drupal\Core\Extension\ThemeHandlerInterface $themeHandler
   *   The theme handler.
   */
  public function __construct(ThemeHandlerInterface $themeHandler) {
    $this->themeHandler = $themeHandler;
  }

  /**
   * {@inheritdoc}
   */
  public function getNodeVisitors() {
    $default = $this->themeHandler->getTheme($this->themeHandler->getDefault());
    return [new TrancNodeVisitor(realpath($default->getPath()))];
  }

  /**
   * {@inheritdoc}
   */
  public function getFilters() {
    return [
      new \Twig_SimpleFilter('tc', 'tc', ['is_safe' => ['html']]),
      new \Twig_SimpleFilter('transc', 'tc', ['is_safe' => ['html']]),
      new \Twig_SimpleFilter('ti', 't', ['is_safe' => ['html']]),
      new \Twig_SimpleFilter('transi', 't', ['is_safe' => ['html']]),
    ];
  }

}
